[Botkit](../README.md) > [Botkit](../classes/botkit.botkit-1.md)

# Class: Botkit

Create a new instance of Botkit to define the controller for a conversational app. To connect Botkit to a chat platform, pass in a fully configured `adapter`. If one is not specified, Botkit will expose an adapter for the Microsoft Bot Framework.

## Hierarchy

**Botkit**

## Index

### Constructors

* [constructor](botkit.botkit-1.md#constructor)

### Properties

* [PATH](botkit.botkit-1.md#path)
* [adapter](botkit.botkit-1.md#adapter)
* [booted](botkit.botkit-1.md#booted)
* [cms](botkit.botkit-1.md#cms)
* [dialogSet](botkit.botkit-1.md#dialogset)
* [http](botkit.botkit-1.md#http)
* [plugins](botkit.botkit-1.md#plugins)
* [storage](botkit.botkit-1.md#storage)
* [version](botkit.botkit-1.md#version)
* [webserver](botkit.botkit-1.md#webserver)

### Methods

* [addDep](botkit.botkit-1.md#adddep)
* [completeDep](botkit.botkit-1.md#completedep)
* [getConfig](botkit.botkit-1.md#getconfig)
* [handleTurn](botkit.botkit-1.md#handleturn)
* [hears](botkit.botkit-1.md#hears)
* [ingest](botkit.botkit-1.md#ingest)
* [interrupts](botkit.botkit-1.md#interrupts)
* [loadModule](botkit.botkit-1.md#loadmodule)
* [loadModules](botkit.botkit-1.md#loadmodules)
* [on](botkit.botkit-1.md#on)
* [saveState](botkit.botkit-1.md#savestate)
* [spawn](botkit.botkit-1.md#spawn)
* [trigger](botkit.botkit-1.md#trigger)

### Object literals

* [middleware](botkit.botkit-1.md#middleware)

---

## Constructors

<a id="constructor"></a>

###  constructor

⊕ **new Botkit**(config: *`any`*): [Botkit](botkit.botkit-1.md)

*Defined in [core.ts:95](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/core.ts#L95)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| config | `any` |

**Returns:** [Botkit](botkit.botkit-1.md)

___

## Properties

<a id="path"></a>

###  PATH

**● PATH**: *`string`*

*Defined in [core.ts:93](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/core.ts#L93)*

___
<a id="adapter"></a>

###  adapter

**● adapter**: *`any`*

*Defined in [core.ts:89](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/core.ts#L89)*

___
<a id="booted"></a>

###  booted

**● booted**: *`boolean`*

*Defined in [core.ts:95](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/core.ts#L95)*

___
<a id="cms"></a>

###  cms

**● cms**: *[BotkitCMSHelper](botkit.botkitcmshelper.md)*

*Defined in [core.ts:75](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/core.ts#L75)*

___
<a id="dialogset"></a>

###  dialogSet

**● dialogSet**: *`DialogSet`*

*Defined in [core.ts:90](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/core.ts#L90)*

___
<a id="http"></a>

###  http

**● http**: *`any`*

*Defined in [core.ts:88](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/core.ts#L88)*

___
<a id="plugins"></a>

###  plugins

**● plugins**: *[BotkitPluginLoader](botkit.botkitpluginloader.md)*

*Defined in [core.ts:91](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/core.ts#L91)*

___
<a id="storage"></a>

###  storage

**● storage**: *`Storage`*

*Defined in [core.ts:86](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/core.ts#L86)*

___
<a id="version"></a>

###  version

**● version**: *`string`* =  require('../package.json').version

*Defined in [core.ts:77](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/core.ts#L77)*

___
<a id="webserver"></a>

###  webserver

**● webserver**: *`any`*

*Defined in [core.ts:87](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/core.ts#L87)*

___

## Methods

<a id="adddep"></a>

###  addDep

▸ **addDep**(name: *`any`*): `void`

*Defined in [core.ts:237](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/core.ts#L237)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| name | `any` |

**Returns:** `void`

___
<a id="completedep"></a>

###  completeDep

▸ **completeDep**(name: *`any`*): `boolean`

*Defined in [core.ts:242](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/core.ts#L242)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| name | `any` |

**Returns:** `boolean`

___
<a id="getconfig"></a>

###  getConfig

▸ **getConfig**(key?: *`string`*): `any`

*Defined in [core.ts:229](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/core.ts#L229)*

Get a value from the configuration

**Parameters:**

| Name | Type | Description |
| ------ | ------ | ------ |
| `Optional` key | `string` |  The name of a value stored in the configuration |

**Returns:** `any`
The value stored in the configuration (or null if absent)

___
<a id="handleturn"></a>

###  handleTurn

▸ **handleTurn**(turnContext: *`any`*): `Promise`<`any`>

*Defined in [core.ts:291](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/core.ts#L291)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| turnContext | `any` |

**Returns:** `Promise`<`any`>

___
<a id="hears"></a>

###  hears

▸ **hears**(patterns: *(`string` \| `RegExp` \| `function`)[] \| `RegExp` \| `RegExp`[] \| `string` \| `function`*, events: *`string` \| `string`[]*, handler: *`function`*): `void`

*Defined in [core.ts:442](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/core.ts#L442)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| patterns | (`string` \| `RegExp` \| `function`)[] \| `RegExp` \| `RegExp`[] \| `string` \| `function` |
| events | `string` \| `string`[] |
| handler | `function` |

**Returns:** `void`

___
<a id="ingest"></a>

###  ingest

▸ **ingest**(bot: *[BotWorker](botkit.botworker.md)*, message: *[BotkitMessage](../interfaces/botkit.botkitmessage.md)*): `Promise`<`any`>

*Defined in [core.ts:353](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/core.ts#L353)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| bot | [BotWorker](botkit.botworker.md) |
| message | [BotkitMessage](../interfaces/botkit.botkitmessage.md) |

**Returns:** `Promise`<`any`>

___
<a id="interrupts"></a>

###  interrupts

▸ **interrupts**(patterns: *(`string` \| `RegExp` \| `function`)[] \| `RegExp` \| `RegExp`[] \| `string` \| `function`*, events: *`string` \| `string`[]*, handler: *`function`*): `void`

*Defined in [core.ts:486](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/core.ts#L486)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| patterns | (`string` \| `RegExp` \| `function`)[] \| `RegExp` \| `RegExp`[] \| `string` \| `function` |
| events | `string` \| `string`[] |
| handler | `function` |

**Returns:** `void`

___
<a id="loadmodule"></a>

###  loadModule

▸ **loadModule**(p: *`string`*): `void`

*Defined in [core.ts:601](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/core.ts#L601)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| p | `string` |

**Returns:** `void`

___
<a id="loadmodules"></a>

###  loadModules

▸ **loadModules**(p: *`string`*): `void`

*Defined in [core.ts:606](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/core.ts#L606)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| p | `string` |

**Returns:** `void`

___
<a id="on"></a>

###  on

▸ **on**(events: *`string` \| `string`[]*, handler: *`function`*): `void`

*Defined in [core.ts:530](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/core.ts#L530)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| events | `string` \| `string`[] |
| handler | `function` |

**Returns:** `void`

___
<a id="savestate"></a>

###  saveState

▸ **saveState**(bot: *`any`*): `Promise`<`void`>

*Defined in [core.ts:349](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/core.ts#L349)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| bot | `any` |

**Returns:** `Promise`<`void`>

___
<a id="spawn"></a>

###  spawn

▸ **spawn**(config: *`any`*): `Promise`<[BotWorker](botkit.botworker.md)>

*Defined in [core.ts:565](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/core.ts#L565)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| config | `any` |

**Returns:** `Promise`<[BotWorker](botkit.botworker.md)>

___
<a id="trigger"></a>

###  trigger

▸ **trigger**(event: *`string`*, bot: *[BotWorker](botkit.botworker.md)*, message: *[BotkitMessage](../interfaces/botkit.botkitmessage.md)*): `Promise`<`any`>

*Defined in [core.ts:549](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/core.ts#L549)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| event | `string` |
| bot | [BotWorker](botkit.botworker.md) |
| message | [BotkitMessage](../interfaces/botkit.botkitmessage.md) |

**Returns:** `Promise`<`any`>

___

## Object literals

<a id="middleware"></a>

###  middleware

**middleware**: *`object`*

*Defined in [core.ts:79](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/core.ts#L79)*

<a id="middleware.ingest-1"></a>

####  ingest

**● ingest**: *`any`* =  new ware()

*Defined in [core.ts:81](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/core.ts#L81)*

___
<a id="middleware.receive"></a>

####  receive

**● receive**: *`any`* =  new ware()

*Defined in [core.ts:83](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/core.ts#L83)*

___
<a id="middleware.send"></a>

####  send

**● send**: *`any`* =  new ware()

*Defined in [core.ts:82](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/core.ts#L82)*

___
<a id="middleware.spawn-1"></a>

####  spawn

**● spawn**: *`any`* =  new ware()

*Defined in [core.ts:80](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/core.ts#L80)*

___

___

