[Botkit](../README.md) > [BotkitConversation](../classes/botkit.botkitconversation.md)

# Class: BotkitConversation

## Type parameters
#### O :  `object`
## Hierarchy

 `any`

**↳ BotkitConversation**

## Index

### Constructors

* [constructor](botkit.botkitconversation.md#constructor)

### Properties

* [script](botkit.botkitconversation.md#script)

### Methods

* [addMessage](botkit.botkitconversation.md#addmessage)
* [addQuestion](botkit.botkitconversation.md#addquestion)
* [after](botkit.botkitconversation.md#after)
* [ask](botkit.botkitconversation.md#ask)
* [before](botkit.botkitconversation.md#before)
* [beginDialog](botkit.botkitconversation.md#begindialog)
* [continueDialog](botkit.botkitconversation.md#continuedialog)
* [end](botkit.botkitconversation.md#end)
* [endDialog](botkit.botkitconversation.md#enddialog)
* [gotoThread](botkit.botkitconversation.md#gotothread)
* [onChange](botkit.botkitconversation.md#onchange)
* [onStep](botkit.botkitconversation.md#onstep)
* [resumeDialog](botkit.botkitconversation.md#resumedialog)
* [runStep](botkit.botkitconversation.md#runstep)
* [say](botkit.botkitconversation.md#say)

---

## Constructors

<a id="constructor"></a>

###  constructor

⊕ **new BotkitConversation**(dialogId: *`string`*, controller: *`any`*): [BotkitConversation](botkit.botkitconversation.md)

*Defined in [conversation.ts:17](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/conversation.ts#L17)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| dialogId | `string` |
| controller | `any` |

**Returns:** [BotkitConversation](botkit.botkitconversation.md)

___

## Properties

<a id="script"></a>

###  script

**● script**: *`any`*

*Defined in [conversation.ts:12](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/conversation.ts#L12)*

___

## Methods

<a id="addmessage"></a>

###  addMessage

▸ **addMessage**(message: *`any`*, thread_name: *`any`*): `void`

*Defined in [conversation.ts:42](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/conversation.ts#L42)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| message | `any` |
| thread_name | `any` |

**Returns:** `void`

___
<a id="addquestion"></a>

###  addQuestion

▸ **addQuestion**(message: *`any`*, handlers: *`any`*, options: *`any`*, thread_name: *`any`*): `void`

*Defined in [conversation.ts:62](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/conversation.ts#L62)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| message | `any` |
| handlers | `any` |
| options | `any` |
| thread_name | `any` |

**Returns:** `void`

___
<a id="after"></a>

###  after

▸ **after**(handler: *`function`*): `void`

*Defined in [conversation.ts:125](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/conversation.ts#L125)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| handler | `function` |

**Returns:** `void`

___
<a id="ask"></a>

###  ask

▸ **ask**(message: *`any`*, handlers: *`any`*, options: *`any`*): `void`

*Defined in [conversation.ts:58](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/conversation.ts#L58)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| message | `any` |
| handlers | `any` |
| options | `any` |

**Returns:** `void`

___
<a id="before"></a>

###  before

▸ **before**(thread_name: *`any`*, handler: *`any`*): `void`

*Defined in [conversation.ts:97](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/conversation.ts#L97)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| thread_name | `any` |
| handler | `any` |

**Returns:** `void`

___
<a id="begindialog"></a>

###  beginDialog

▸ **beginDialog**(dc: *`any`*, options: *`any`*): `Promise`<`any`>

*Defined in [conversation.ts:168](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/conversation.ts#L168)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| dc | `any` |
| options | `any` |

**Returns:** `Promise`<`any`>

___
<a id="continuedialog"></a>

###  continueDialog

▸ **continueDialog**(dc: *`any`*): `Promise`<`any`>

*Defined in [conversation.ts:178](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/conversation.ts#L178)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| dc | `any` |

**Returns:** `Promise`<`any`>

___
<a id="end"></a>

###  end

▸ **end**(dc: *`DialogContext`*, value: *`any`*): `Promise`<`any`>

*Defined in [conversation.ts:349](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/conversation.ts#L349)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| dc | `DialogContext` |
| value | `any` |

**Returns:** `Promise`<`any`>

___
<a id="enddialog"></a>

###  endDialog

▸ **endDialog**(context: *`TurnContext`*, instance: *`DialogInstance`*, reason: *`DialogReason`*): `Promise`<`void`>

*Defined in [conversation.ts:363](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/conversation.ts#L363)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| context | `TurnContext` |
| instance | `DialogInstance` |
| reason | `DialogReason` |

**Returns:** `Promise`<`void`>

___
<a id="gotothread"></a>

###  gotoThread

▸ **gotoThread**(thread: *`any`*, dc: *`any`*, step: *`any`*): `Promise`<`void`>

*Defined in [conversation.ts:435](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/conversation.ts#L435)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| thread | `any` |
| dc | `any` |
| step | `any` |

**Returns:** `Promise`<`void`>

___
<a id="onchange"></a>

###  onChange

▸ **onChange**(variable: *`any`*, handler: *`any`*): `void`

*Defined in [conversation.ts:141](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/conversation.ts#L141)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| variable | `any` |
| handler | `any` |

**Returns:** `void`

___
<a id="onstep"></a>

###  onStep

▸ **onStep**(dc: *`any`*, step: *`any`*): `any`

*Defined in [conversation.ts:196](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/conversation.ts#L196)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| dc | `any` |
| step | `any` |

**Returns:** `any`

___
<a id="resumedialog"></a>

###  resumeDialog

▸ **resumeDialog**(dc: *`any`*, reason: *`any`*, result: *`any`*): `Promise`<`any`>

*Defined in [conversation.ts:190](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/conversation.ts#L190)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| dc | `any` |
| reason | `any` |
| result | `any` |

**Returns:** `Promise`<`any`>

___
<a id="runstep"></a>

###  runStep

▸ **runStep**(dc: *`any`*, index: *`any`*, thread_name: *`any`*, reason: *`any`*, result?: *`any`*): `any`

*Defined in [conversation.ts:297](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/conversation.ts#L297)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| dc | `any` |
| index | `any` |
| thread_name | `any` |
| reason | `any` |
| `Optional` result | `any` |

**Returns:** `any`

___
<a id="say"></a>

###  say

▸ **say**(message: *`any`*): `void`

*Defined in [conversation.ts:38](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/conversation.ts#L38)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| message | `any` |

**Returns:** `void`

___

