[Botkit](../README.md) > [BotWorker](../classes/botkit.botworker.md)

# Class: BotWorker

## Hierarchy

**BotWorker**

## Index

### Constructors

* [constructor](botkit.botworker.md#constructor)

### Accessors

* [controller](botkit.botworker.md#controller)

### Methods

* [beginDialog](botkit.botworker.md#begindialog)
* [changeContext](botkit.botworker.md#changecontext)
* [ensureMessageFormat](botkit.botworker.md#ensuremessageformat)
* [getConfig](botkit.botworker.md#getconfig)
* [httpBody](botkit.botworker.md#httpbody)
* [httpStatus](botkit.botworker.md#httpstatus)
* [reply](botkit.botworker.md#reply)
* [say](botkit.botworker.md#say)

---

## Constructors

<a id="constructor"></a>

###  constructor

⊕ **new BotWorker**(controller: *`any`*, config: *`any`*): [BotWorker](botkit.botworker.md)

*Defined in [botworker.ts:12](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/botworker.ts#L12)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| controller | `any` |
| config | `any` |

**Returns:** [BotWorker](botkit.botworker.md)

___

## Accessors

<a id="controller"></a>

###  controller

**get controller**(): [Botkit](botkit.botkit-1.md)

*Defined in [botworker.ts:22](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/botworker.ts#L22)*

**Returns:** [Botkit](botkit.botkit-1.md)

___

## Methods

<a id="begindialog"></a>

###  beginDialog

▸ **beginDialog**(id: *`any`*, options: *`any`*): `Promise`<`void`>

*Defined in [botworker.ts:68](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/botworker.ts#L68)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| id | `any` |
| options | `any` |

**Returns:** `Promise`<`void`>

___
<a id="changecontext"></a>

###  changeContext

▸ **changeContext**(reference: *`Partial`<`ConversationReference`>*): `Promise`<[BotWorker](botkit.botworker.md)>

*Defined in [botworker.ts:80](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/botworker.ts#L80)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| reference | `Partial`<`ConversationReference`> |

**Returns:** `Promise`<[BotWorker](botkit.botworker.md)>

___
<a id="ensuremessageformat"></a>

###  ensureMessageFormat

▸ **ensureMessageFormat**(message: *`any`*): `Partial`<`Activity`>

*Defined in [botworker.ts:109](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/botworker.ts#L109)*

Take a crudely-formed Botkit message with any sort of field and map it into a beautiful BotFramework activity

**Parameters:**

| Name | Type |
| ------ | ------ |
| message | `any` |

**Returns:** `Partial`<`Activity`>

___
<a id="getconfig"></a>

###  getConfig

▸ **getConfig**(key?: *`string`*): `any`

*Defined in [botworker.ts:27](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/botworker.ts#L27)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| `Optional` key | `string` |

**Returns:** `any`

___
<a id="httpbody"></a>

###  httpBody

▸ **httpBody**(body: *`any`*): `void`

*Defined in [botworker.ts:170](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/botworker.ts#L170)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| body | `any` |

**Returns:** `void`

___
<a id="httpstatus"></a>

###  httpStatus

▸ **httpStatus**(status: *`number`*): `void`

*Defined in [botworker.ts:162](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/botworker.ts#L162)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| status | `number` |

**Returns:** `void`

___
<a id="reply"></a>

###  reply

▸ **reply**(src: *`Partial`<[BotkitMessage](../interfaces/botkit.botkitmessage.md)>*, resp: *`Partial`<[BotkitMessage](../interfaces/botkit.botkitmessage.md)>*): `Promise`<`any`>

*Defined in [botworker.ts:50](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/botworker.ts#L50)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| src | `Partial`<[BotkitMessage](../interfaces/botkit.botkitmessage.md)> |
| resp | `Partial`<[BotkitMessage](../interfaces/botkit.botkitmessage.md)> |

**Returns:** `Promise`<`any`>

___
<a id="say"></a>

###  say

▸ **say**(message: *`Partial`<[BotkitMessage](../interfaces/botkit.botkitmessage.md)>*): `Promise`<`any`>

*Defined in [botworker.ts:36](https://github.com/howdyai/botkit/blob/1a3592f/packages/botkit/src/botworker.ts#L36)*

**Parameters:**

| Name | Type |
| ------ | ------ |
| message | `Partial`<[BotkitMessage](../interfaces/botkit.botkitmessage.md)> |

**Returns:** `Promise`<`any`>

___

