/**
 * @module botkit
 */
import { Botkit, BotkitMessage } from './core';
import { Activity, ConversationReference } from 'botbuilder';
export declare class BotWorker {
    private _controller;
    private _config;
    constructor(controller: any, config: any);
    readonly controller: Botkit;
    getConfig(key?: string): any;
    say(message: Partial<BotkitMessage>): Promise<any>;
    reply(src: Partial<BotkitMessage>, resp: Partial<BotkitMessage>): Promise<any>;
    beginDialog(id: any, options: any): Promise<void>;
    changeContext(reference: Partial<ConversationReference>): Promise<BotWorker>;
    /**
     * Take a crudely-formed Botkit message with any sort of field
     * and map it into a beautiful BotFramework activity
     */
    ensureMessageFormat(message: any): Partial<Activity>;
    httpStatus(status: number): void;
    httpBody(body: any): void;
}
